#!/usr/bin/env node
// Generated by CoffeeScript 2.4.1
  //!/usr/bin/env coffee
var $, AppName, D, E, Fs, GetOpt, JSONPathUrl, P, PackageName, Path, RecipeNodeJs, TwitterDoc, Util, _, a, c, candiates, commandWithoutId, ctx, e, findShortestAbbreviation, getCommandList, getParamsList, i, injectData, k, len, len1, n, optUsages, proc, q, ref, ref1, ref2, ref3, ref4, ref5, ref6, resolveAbbreviation, restCallback,
  indexOf = [].indexOf;

GetOpt = require('@kssfilo/getopt');

Fs = require('fs');

Path = require('path');

Util = require('util');

({RecipeNodeJs} = require('recipe-js'));

_ = require('lodash');

TwitterDoc = require('./twitterapi.json');

AppName = "twitter";

PackageName = "twitter-tool";

JSONPathUrl = "https://goessner.net/articles/JsonPath/";

P = console.log;

E = (e) => {
  var ref, ref1;
  switch (false) {
    case (ref = typeof e) !== 'string' && ref !== 'value':
      return console.error(e);
    case !ctx.isDebugMode:
      return console.error(e);
    default:
      if ((ref1 = e[0]) != null ? ref1.message : void 0) {
        return console.error(e[0].message);
      } else {
        return console.error.toString();
      }
  }
};

D = (str) => {
  if (ctx.isDebugMode) {
    return E(`${AppName}:` + str);
  }
};

findShortestAbbreviation = (k, candiates, sep) => {
  var a, ds, e, f, i, j, len, n, ra, s, shortest, wasDebugMode;
  s = k.split(sep);
  ds = (function() {
    var len, n, results1;
    results1 = [];
    for (i = n = 0, len = s.length; n < len; i = ++n) {
      a = s[i];
      if (sep === '/' && a === ':id') {
        results1.push([a]);
      } else {
        results1.push((function() {
          var q, ref, results3;
          results3 = [];
          for (j = q = 1, ref = a.length; (1 <= ref ? q <= ref : q >= ref); j = 1 <= ref ? ++q : --q) {
            results3.push(a.substr(0, j));
          }
          return results3;
        })());
      }
    }
    return results1;
  })();
  f = (c, rst, sep, resultArray) => {
    var b, d, myRst, r;
    if (rst.length === 0) {
      resultArray.push(c);
      return c;
    }
    myRst = [].concat(rst);
    d = myRst.shift();
    r = (function() {
      var len, n, results1;
      results1 = [];
      for (n = 0, len = d.length; n < len; n++) {
        i = d[n];
        b = _.concat(c, i);
        results1.push(f(b, myRst, sep, resultArray));
      }
      return results1;
    })();
    return r;
  };
  ra = [];
  f([], ds, sep, ra);
  ra = (function() {
    var len, n, results1;
    results1 = [];
    for (n = 0, len = ra.length; n < len; n++) {
      i = ra[n];
      results1.push(i.join(sep));
    }
    return results1;
  })();
  ra.sort((a, b) => {
    if (a.length > b.length) {
      return 1;
    } else {
      return -1;
    }
  });
  wasDebugMode = ctx.isDebugMode;
  ctx.isDebugMode = false; //turn off debug mode tempolary
  shortest = k;
  for (n = 0, len = ra.length; n < len; n++) {
    i = ra[n];
    try {
      resolveAbbreviation(i, sep, candiates, false);
      shortest = i;
      break;
    } catch (error1) {
      e = error1;
      true;
    }
  }
  ctx.isDebugMode = wasDebugMode;
  return shortest;
};

resolveAbbreviation = (abr, sep, cand, keepId = true) => {
  var a, f, i, id, ref, s, s2;
  D(`checking abbreviations for ${(sep === '/' ? 'restCommand' : 'param')} `);
  a = abr;
  if (sep === '/') {
    id = (ref = a.match(/\/(\d+)$/)) != null ? ref[1] : void 0;
    a = a.replace(/\/\d+$/, "/:id");
  }
  if (indexOf.call(cand, a) >= 0) {
    D(`${a} is found in command/param list.`);
    if (keepId) {
      return abr;
    } else {
      return a;
    }
  }
  s = a.split(sep);
  s2 = ((function() {
    var len, n, results1;
    results1 = [];
    for (n = 0, len = s.length; n < len; n++) {
      i = s[n];
      results1.push(i !== ':id' ? i + `[^${sep}]*?` : i);
    }
    return results1;
  })()).join(sep);
  s2 = `^${s2}$`;
  D(`trying to search by ${s2}`);
  f = cand.filter((i) => {
    return i.match(new RegExp(s2));
  });
  if (f.length === 0) {
    if (ctx.isForceExecute) {
      return abr;
    }
    if (sep === '/') {
      throw `there are no such command '${a}'. see -h`;
    }
    if (sep === '_') {
      throw `there are no such param '${a}'. see -h <command>`;
    }
  } else if (f.length >= 2) {
    throw `ambiguous command/param '${a}'. candiates are ${JSON.stringify(f)}`;
  } else {
    abr = f[0];
    if (sep === '/' && keepId) {
      if (id != null) {
        abr = abr.replace(/:id/, id);
      }
    }
    D(`matched:${abr}`);
    return abr;
  }
};

getCommandList = (doc, width = null) => {
  var i, k, len, len1, maxlen, n, num, q, r, ref, s, sr, v;
  r = [];
  ref = Object.keys(doc);
  for (n = 0, len = ref.length; n < len; n++) {
    k = ref[n];
    r.push(`${k} (${findShortestAbbreviation(k, Object.keys(doc), '/')})`);
  }
  r.sort();
  if (width == null) {
    return r.join(" | ");
  } else {
    maxlen = _.max((function() {
      var len1, q, results1;
      results1 = [];
      for (q = 0, len1 = r.length; q < len1; q++) {
        i = r[q];
        results1.push(i.length);
      }
      return results1;
    })());
//D maxlen
    for (i = q = 0, len1 = r.length; q < len1; i = ++q) {
      v = r[i];
      r[i] = _.padEnd(v, maxlen);
    }
    num = Math.floor(width / maxlen);
    //D num
    sr = '';
    i = 0;
    while ((s = r.shift())) {
      sr += s;
      i++;
      if (i % num === 0) {
        sr += "\n";
      }
    }
    return sr;
  }
};

getParamsList = (command, doc) => {
  var d, i, k, len, len1, len2, maxlen, n, pns, q, r, u, v;
  r = [];
  D(`looking up parameters for ${command}`);
  d = doc[command].params;
  pns = (function() {
    var len, n, results1;
    results1 = [];
    for (n = 0, len = d.length; n < len; n++) {
      i = d[n];
      results1.push(i.name);
    }
    return results1;
  })();
  for (n = 0, len = pns.length; n < len; n++) {
    k = pns[n];
    r.push(`${k}(${findShortestAbbreviation(k, pns, '_')})`);
  }
  maxlen = _.max((function() {
    var len1, q, results1;
    results1 = [];
    for (q = 0, len1 = r.length; q < len1; q++) {
      i = r[q];
      results1.push(i.length);
    }
    return results1;
  })());
  for (i = q = 0, len1 = r.length; q < len1; i = ++q) {
    v = r[i];
    r[i] = _.padEnd(v, maxlen);
  }
  for (i = u = 0, len2 = d.length; u < len2; i = ++u) {
    v = d[i];
    r[i] += ` : ${v.required} : ${v.description}`;
  }
  return r.join("\n");
};

ctx = {
  isDebugMode: false,
  isRecipeJsDebugMode: false,
  userName: (ref = typeof process !== "undefined" && process !== null ? process.env['TWITTER_USER'] : void 0) != null ? ref : null,
  command: 'auto',
  restParam: null,
  outputJsonSeparator: "\t",
  jsonPath: null,
  outputCsv: false,
  outputFileName: null,
  uploadFiles: [],
  isCheckCommand: false,
  isRemoveReturnCode: false,
  isForceExecute: false,
  inspectDepth: 0,
  inspectAdjustCount: 5
};

optUsages = {
  h: ["command", "show help and command list.if you specify command name, you can see details."],
  "?": ["command", ""],
  d: "debug mode",
  D: "debug mode (+ recipe-js debug messages)",
  u: ["username", "specify your user name like @username or username. you can set default by TWITTER_USER environment variable "],
  g: ["command", `force GET request.command is Twitter REST Api command. e.g. 'search/tweets'. see $ ${AppName} -h`],
  p: ["command", `force POST request. normally,you don't need to specify -g or -p . ${PackageName} guesses method by command`],
  o: ["jsonstring", "parameters for GET/POST request. JSON format like '{\"q\":\"#nodejs\"}'.you can omit outer {} and double quote. e.g 'q:#nodejs,lang:ja' "],
  e: ["depth", "outputs default format(Util.inspect). default depth is 0 or 1(if result is array or few). you can add depth by this option e.g -i 2."],
  j: ["jsonpath", `outputs JSON format.filters by given JSONPath. you can specify multiple like -j '$.id|$.name'.output will be 2 dimention array in this case. about JSONPath, see ${JSONPathUrl}`],
  J: ["jsonpath", "outputs CSV format(separated by ,) if JSONPath indicate single value, -J output is like a string or value. e.g '$.statuses[0].id' -> 12345689 "],
  l: "compress output JSON to single line",
  r: "removes all return codes from result.",
  O: ["filename", "write results to file (default:stdout)"],
  m: ["filename", "media file such as jpg/png, you don't need to specify 'media_ids' in -o param. -m option can be specified max 4 times"],
  T: "inject Twitter REST API result JSON from stdin instead of accessing Twitter. you can use JSONPath(-j /-J) to parse it. for reusing result or testing purpose",
  n: "does no not anything. (for checking command/params abbreviation.)",
  c: "verify credentials(for checking communication to Twitter server)",
  i: "set up for specified user",
  I: "initialize all data then setup App key again"
};

try {
  GetOpt.setopt('h::?::dDu:g:p:o:e::j::J::lrO:m:TnciI');
} catch (error1) {
  e = error1;
  switch (e.type) {
    case 'unknown':
      E(`Unknown option:${e.opt}`);
      break;
    case 'required':
      E(`Required parameter for option:${e.opt}`);
  }
  process.exit(1);
}

try {
  GetOpt.getopt(function(o, p) {
    var j, jb, js;
    switch (o) {
      case 'h':
      case '?':
        ctx.command = 'usage';
        if (p[0] !== '') {
          return ctx.restCommand = p[0];
        }
        break;
      case 'd':
        return ctx.isDebugMode = true;
      case 'D':
        ctx.isDebugMode = true;
        return ctx.isRecipeJsDebugMode = true;
      case 'u':
        return ctx.userName = p[0].replace(/^@/, '');
      case 'g':
        ctx.command = 'GET';
        ctx.restCommand = p[0];
        return ctx.isForceExecute = true;
      case 'p':
        ctx.command = 'POST';
        ctx.restCommand = p[0];
        return ctx.isForceExecute = true;
      case 'O':
        return ctx.outputFileName = p[0];
      case 'T':
        return ctx.command = 'inject';
      case 'j':
        return ctx.jsonPath = p[0] !== '' ? p[0] : "";
      case 'm':
        return ctx.uploadFiles = p;
      case 'J':
        ctx.jsonPath = p[0] !== '' ? p[0] : "";
        return ctx.outputCsv = true;
      case 'e':
        return ctx.inspectDepth = p[0] !== '' ? Number(p[0]) : ctx.inspectDepth;
      case 'r':
        return ctx.isRemoveReturnCode = true;
      case 'l':
        return ctx.outputJsonSeparator = null;
      case 'n':
        return ctx.isCheckCommand = true;
      case 'c':
        ctx.command = 'GET';
        ctx.restCommand = 'account/verify_credentials';
        ctx.jsonPath = '$.name|$.screen_name|$.location|$.description';
        ctx.outputCsv = true;
        return E("trying to verify your credential. if you see your info below, It's OK.");
      case 'o':
        try {
          return ctx.restParam = JSON.parse(p[0]);
        } catch (error1) {
          e = error1;
          D(`-o arg looks like not JSON. try to convert '${p[0]}'`);
          j = p[0].trim();
          jb = j.replace(/^ *{ *(.+?) *} *$/, "$1");
          D(`outer {} removed:'${jb}'`);
          js = jb.split(/, *(?=[^ ,]+:)/);
          D(`splited:${JSON.stringify(js)}`);
          js = js.map((x) => {
            return x.replace(/^ *["']?([^:]+?)["']? *: *['"]?(.+?)['"]? *$/, "\"$1\":\"$2\"");
          });
          j = `{${js.join(',')}}`;
          D(`converterd: ${j}`);
          try {
            ctx.restParam = JSON.parse(j);
            return D(`success: ${JSON.stringify(ctx.restParam)}`);
          } catch (error1) {
            e = error1;
            E(`-o invalid parameter. ${j} `);
            return process.exit(1);
          }
        }
        break;
      case 'i':
        return ctx.command = 'initUser';
      case 'I':
        return ctx.command = 'initAll';
    }
  });
  if (ctx.command === 'auto') {
    if (GetOpt.params().length > 0) {
      ctx.restCommand = GetOpt.params()[0];
      D(`auto mode.restCommand is '${ctx.restCommand}'`);
    }
  }
  if (ctx.command === 'usage') {
    if (ctx.restCommand == null) {
      P(`## Command line\n\n    ${AppName} [-u <username>] <command> [options]\n	\n    Twitter Command Line Tool.simple but flexible interface to access all REST API by short abbreviated commands then easy to re-use data by JSONPath/CSV. JPG/PNG upload support.\n    \n    Copyright (C) 2019-2021 @kssfilo(https://kanasys.com/gtech/)\n\n## Options\n\n${GetOpt.getHelp(optUsages)}		\n\n## Examples\n\n### tweet\n\n    $ ${AppName} -u @yourtwitterid statuses/update -o '{"status":"Hello from ${PackageName}!"}'\n    \nor (abbreviation)\n    \n    $ ${AppName} -u yourtwitterid s/up -o 's:Hello from ${PackageName}!'\n    \nor (environment variable+abbreviation)\n    \n    $ export TWITTER_USER=yourtwitterid\n    $ ${AppName} s/up -o 's:Hello from ${PackageName}!'\n\n### tweet with jpg/png\n\n    $ ${AppName} s/up -o 's_n:Photo from ${PackageName}!' -m photo.jpg\n\n### search and print CSV by JSONPath\n\n    $ ${AppName} s/t -o 'q:#nodejs (awesome OR nice)' -rJ $.statuses[*].text\n\n### checking timeline and JSON output by JSONPath\n\n    $ ${AppName} s/h -rJ '$[*].user.name|$[*].text'\n    #you can chain JSONPath by '|'\n	\nabout JSONPath see ${JSONPathUrl} for more informaton. \n\nyou should combine with [norl](https://www.npmjs.com/package/norl) to do more complex JSON processing.\n\n## Setup\n\n    $ ${AppName} -I\n\nthen \n	\n    $ ${AppName} -u @username -i\n\n## Commands (abbreviation)\n\n\`\`\`\n${getCommandList(TwitterDoc, 160)}\`\`\`\n\nyou can see details by \`$ ${AppName} -h <command or abbreviation>\`\n\nalso refer https://developer.twitter.com/en/docs/api-reference-index\n\n(for using other commands such as Premium/Enterprise search, you can use -g -p option to avoid command / param check.)`);
    } else {
      c = resolveAbbreviation(ctx.restCommand, '/', Object.keys(TwitterDoc), false);
      P(`\n# ${c} (${findShortestAbbreviation(c, Object.keys(TwitterDoc), '/')})\n\n${((ref1 = TwitterDoc[c]) != null ? ref1.description : void 0)}\n\n## params (abbreviation)\n\n${getParamsList(c, TwitterDoc)}\n\n## refer\n\n${((ref2 = TwitterDoc[c]) != null ? ref2.url : void 0)}\n`);
    }
    process.exit(0);
  }
  D(`==starting ${AppName}`);
  D("-options");
  D(`${JSON.stringify(ctx, null, 2)}`);
  D("-------");
  D("sanity checking..");
  if (((ctx.userName == null) || ctx.userName === '') && !((ref3 = ctx.command) === 'initAll' || ref3 === 'inject' || ref3 === 'nothing') && !ctx.isCheckCommand) {
    throw "you must specify your user name like '-u @username or -u username' or export TWITTER_USER=username";
  }
  // E  "warning:you may have to pass parameters as JSON by -o option.  e.g. -o '{\"screen_name\":\"nodejs\"}' to suppress this warning. supply -o {} " if ctx.command in ['get','post'] and !ctx.restParam?
  if (ctx.restCommand != null) {
    ctx.restCommand = resolveAbbreviation(ctx.restCommand, '/', Object.keys(TwitterDoc));
    if (ctx.command === 'auto') {
      commandWithoutId = resolveAbbreviation(ctx.restCommand, '/', Object.keys(TwitterDoc), false);
      ctx.command = TwitterDoc[commandWithoutId].method;
      if ((ref4 = ctx.command) !== 'GET' && ref4 !== 'POST') {
        throw "sorry, couldn't guessed method(GET/POST) for this command. use -g or -p";
      }
      D(`guessed method is ${ctx.command}`);
    }
  }
  if (ctx.restParam != null) {
    candiates = (function() {
      var len, n, ref5, ref6, ref7, results1;
      ref7 = (ref5 = (ref6 = TwitterDoc[ctx.restCommand]) != null ? ref6.params : void 0) != null ? ref5 : [];
      results1 = [];
      for (n = 0, len = ref7.length; n < len; n++) {
        i = ref7[n];
        results1.push(i.name);
      }
      return results1;
    })();
    ref5 = Object.keys(ctx.restParam);
    for (n = 0, len = ref5.length; n < len; n++) {
      k = ref5[n];
      a = resolveAbbreviation(k, '_', candiates);
      if (a !== k) {
        ctx.restParam[a] = ctx.restParam[k];
        delete ctx.restParam[k];
      }
    }
  }
  if (ctx.uploadFiles.length > 0) {
    if (ctx.restParam == null) {
      //for v,k of ctx.restParam
      throw `-m is specified to upload media files but no -o option. e.g. '$ ${AppName} s/up -m media.jpg -o 's:Hello'`;
    }
    ref6 = ctx.uploadFiles;
    for (q = 0, len1 = ref6.length; q < len1; q++) {
      i = ref6[q];
      if (!i.match(/(jpeg|jpg|png)$/i)) {
        throw "sorry, only support jpeg/png yet' unless Fs.existsSync i throw "; //{i} doesn't exist"
      }
    }
    if (ctx.restParam.media_ids != null) {
      E("Warning:you don't need to specify 'media_ids' in -o option. overriding.");
    }
    ctx.restParam.media_ids = "@MEDIAIDS@";
  }
  D("..OK");
  if (ctx.isCheckCommand || ctx.isDebugMode) {
    if (ctx.restCommand != null) {
      E(`command:${ctx.restCommand}`);
    }
    if (ctx.restCommand != null) {
      E(`method:${ctx.command}`);
    }
    if (ctx.restParam != null) {
      E(`params:${JSON.stringify(ctx.restParam)}`);
    }
  }
  if (ctx.isCheckCommand) {
    E("check:pass.");
    process.exit(0);
  }
} catch (error1) {
  e = error1;
  E(e);
  process.exit(1);
}

$ = new RecipeNodeJs({
  cacheId: AppName,
  traceEnabled: ctx.isRecipeJsDebugMode,
  debugEnabled: ctx.isRecipeJsDebugMode
});

// OAUTH
$.set('endPoint', 'https://api.twitter.com/oauth');

$.R('consumerKeys', (g, t) => {
  return new Promise((ok, ng) => {
    var consumer_key, consumer_secret, rl, state;
    rl = require('readline').createInterface({
      input: process.stdin
    });
    P(`welcome to ${PackageName}. before using this tool, you have to get 'Consumer API keys'(aka.App key) from Twitter app dashboard.`);
    P("");
    P("https://developer.twitter.com/en/docs/basics/apps/guides/the-app-management-dashboard.html");
    P("");
    P("visit url above and create a new app by Twitter app dashboard. then details->Key and Tokens to see your Consumer API key.");
    P("");
    P("1st,copy and paste Consumer API key(API key) to here:");
    state = 1;
    consumer_key = null;
    consumer_secret = null;
    return rl.on('line', (l) => {
      l = l.trim();
      if (l.length === 0) {
        return;
      }
      switch (state) {
        case 1:
          consumer_key = l;
          state = 2;
          return P("next,copy and paste Consumer API key(API secret key) to here:");
        case 2:
          consumer_secret = l;
          P(`API key:${consumer_key}, API secret key:${consumer_secret}`);
          P("is it ok? [y/n]");
          return state = 3;
        case 3:
          if (l !== 'y') {
            state = 1;
            P("copy and paste Consumer API key(API key) to here:");
          } else {
            P(`thank you. Consumer API key has saved to ~/.recipe-js/${AppName}.json. you can reset it by -I option.`);
            rl.close();
            return ok($.cache(t.target, {
              consumer_key: consumer_key,
              consumer_secret: consumer_secret
            }, null));
          }
      }
    });
  });
});

$.R('accessTokens-%', ['consumerKeys', 'endPoint'], (g, t) => {
  return new Promise((ok, err) => {
    var OAuth, oa;
    ({OAuth} = require('oauth'));
    oa = new OAuth(`${g.endPoint}/request_token`, `${g.endPoint}/access_token`, g[0].consumer_key, g[0].consumer_secret, "1.0", "oob", "HMAC-SHA1");
    return oa.getOAuthRequestToken((error, oauth_token, oauth_token_secret, results) => {
      var authUrl, rl;
      if (error) {
        err(error);
        return;
      }
      authUrl = `${g.endPoint}/authenticate?oauth_token=${oauth_token}`;
      D(`oauth_token:${oauth_token}`);
      D(`oauth_token_secret:${oauth_token_secret}`);
      D(`request token results:${JSON.stringify(results)}`);
      P(`open the url below by a browser and authorize this app for user ${ctx.userName}`);
      P("");
      P(authUrl);
      P("");
      P("then paste the PIN code here:");
      rl = require('readline').createInterface({
        input: process.stdin
      });
      return rl.on('line', (l) => {
        var oauth_verifier;
        if (!l.match(/^[0-9]+$/)) {
          P("invalid PIN code. PIN is like 12345678:");
          return;
        }
        oauth_verifier = l.replace(/[\n\r]/g, '');
        D(`oauth_verifier:${oauth_verifier}`);
        return oa.getOAuthAccessToken(oauth_token, oauth_token_secret, oauth_verifier, (error, oauth_access_token, oauth_access_token_secret, results2) => {
          var requestedUserId;
          if (error) {
            E(error);
            return;
          }
          D(`oauth_access_token:${oauth_access_token}`);
          D(`oauth_token_secret:${oauth_access_token_secret}`);
          D(`access token results:${JSON.stringify(results2)}`);
          D("checking user id..");
          requestedUserId = t.target.replace(/accessTokens-/, '');
          if (results2.screen_name !== requestedUserId) {
            err(`username is not idential:request=[${requestedUserId}],actual=[${results2.screen_name}]`);
            return;
          }
          P(`OK.saving access_token_secret into ~/.recipe-js/${AppName}.json you can reset it by -i option.`);
          ok($.cache(t.target, {oauth_access_token, oauth_access_token_secret}, null));
          return rl.close();
        });
      });
    });
  });
});

$.R('twitterClient-%', ['consumerKeys', 'accessTokens-%'], (g, t) => {
  var Twitter, twitter;
  D("setting up twitter object");
  D(`consumer_key:${g[0].consumer_key}`);
  //D "consumer_secret:#{g[0].consumer_secret}"
  D(`oauth_access_token:${g[1].oauth_access_token}`);
  //D "oauth_access_token_secret:#{g[1].oauth_access_token_secret}"
  Twitter = require('twitter');
  twitter = new Twitter({
    consumer_key: g[0].consumer_key,
    consumer_secret: g[0].consumer_secret,
    access_token_key: g[1].oauth_access_token,
    access_token_secret: g[1].oauth_access_token_secret
  });
  return twitter;
});

// Media Uplorder
$.R('twitterClient', `twitterClient-${ctx.userName}`, (x) => {
  return x;
});

$.F('(?!@mediaid-).*\.(jpeg|jpg|png|JPEG|JPG|PNG)', 'binary');

$.R('@mediaid-(.*)', ['twitterClient', '%'], (g, t) => {
  return new Promise((ok, ng) => {
    var T;
    D(`getting media id:file=${t.deps[1]},length=${g[1].length}bytes`);
    T = g[0];
    return T.post('media/upload', {
      media: g[1]
    }, (e, m, r) => {
      if (e) {
        ng(e);
        return;
      }
      D(`upload success:${JSON.stringify(m)}`);
      return ok(m != null ? m.media_id_string : void 0);
    });
  });
});

$.R('mediaids', ctx.uploadFiles.map((x) => {
  return `@mediaid-${x}`;
}), (gs) => {
  D(`finished to get media ids ${JSON.stringify(gs)}`);
  return gs.join(',');
});

try {
  /*
  $.make 'mediaids'
  .then (mediaids)=>
  	D "FINISH #{JSON.stringify mediaids}"
  	process.exit 1
  .catch (e)=>
  	E e
  	process.exit 1
  */
  // Main
  restCallback = (e, r, s) => {
    var JSONPath, adjust, convertArrayToCSV, f, firstCount, idx, j, len2, len3, len4, p, removeReturnCodeFromString, result, rs, splited, u, w, y;
    D('response');
    if (e) {
      E(e);
      process.exit(1);
    }
    try {
      if (ctx.isRemoveReturnCode) {
        removeReturnCodeFromString = (obj, idx) => {
          if (typeof obj[idx] === 'string') {
            return obj[idx] = obj[idx].replace(/\n/gm, "");
          }
        };
        f = (obj) => {
          var len2, results1, results3, u, v;
          if (typeof obj === 'object') {
            if (Array.isArray(obj)) {
              results1 = [];
              for (i = u = 0, len2 = obj.length; u < len2; i = ++u) {
                v = obj[i];
                if (typeof v === 'object') {
                  results1.push(f(v));
                } else {
                  results1.push(removeReturnCodeFromString(obj, i));
                }
              }
              return results1;
            } else {
              results3 = [];
              for (k in obj) {
                v = obj[k];
                if (typeof v === 'object') {
                  results3.push(f(v));
                } else {
                  results3.push(removeReturnCodeFromString(obj, k));
                }
              }
              return results3;
            }
          }
        };
        f(r);
      }
      if (ctx.jsonPath != null) {
        ({JSONPath} = require('jsonpath-plus'));
        splited = ctx.jsonPath.split('|');
        D(`JSONPathes:JSON.stringify ${splited}`);
        if (splited.length > 1 || ctx.outputCsv) {
          rs = [];
          for (u = 0, len2 = splited.length; u < len2; u++) {
            i = splited[u];
            p = JSONPath({
              path: i,
              json: r,
              wrap: true
            });
            D(`apply:${i} ->`);
            rs.push(p);
          }
          firstCount = rs[0].length;
          for (idx = w = 0, len3 = rs.length; w < len3; idx = ++w) {
            i = rs[idx];
            if (i.length !== firstCount) {
              E(`Warning:${idx}th result length is not same as 1st result`);
            }
            if (ctx.outputCsv) {
// D "converting boolean to string to convert to CSV"
              for (idx = y = 0, len4 = i.length; y < len4; idx = ++y) {
                j = i[idx];
                // D "#{j},#{idx}"
                if (typeof j === 'boolean') {
                  // D "boolean found"
                  i[idx] = j ? 'true' : 'false';
                }
              }
            }
          }
          r = _.zip.apply(null, rs);
          if (ctx.outputCsv && Array.isArray(r)) {
            D("converting array to csv..");
            ({convertArrayToCSV} = require('convert-array-to-csv'));
            r = convertArrayToCSV(r);
          }
        } else {
          if (ctx.jsonPath !== '') {
            p = JSONPath({
              path: ctx.jsonPath,
              json: r,
              wrap: true
            });
            D(`apply:${ctx.jsonPath} ->`);
            r = p;
          }
        }
      } else {
        adjust = 0;
        if (Array.isArray(r) || Object.keys(r).length < ctx.inspectAdjustCount) {
          adjust = 1;
        }
        r = Util.inspect(r, false, ctx.inspectDepth + adjust);
        if (r.match('[Object]')) {
          E("tips: some objects are folded. you can increase inspect depth by -e option. e.g. -e 2 , or use JSONPath(-j / -J )");
        }
      }
    } catch (error1) {
      e = error1;
      E(e);
      process.exit(1);
    }
    result = '';
    if (typeof r === 'object') {
      D('result type is object');
      result = JSON.stringify(r, null, ctx.outputJsonSeparator);
    } else {
      D('result type is string or value');
      result = r;
    }
    if (typeof ctx.outputFileName === 'string') {
      return Fs.writeFileSync(ctx.outputFileName, result);
    } else {
      return process.stdout.write(result + "\n", () => {
        return process.exit(0);
      });
    }
  };
  switch (ctx.command) {
    case 'nothing':
      true;
      break;
    case 'inject':
      injectData = JSON.parse(Fs.readFileSync('/dev/stdin', 'utf8'));
      restCallback(null, injectData, {});
      break;
    case 'GET':
    case 'POST':
      proc = Promise.resolve();
      if (ctx.uploadFiles.length > 0) {
        D(`uploading files ..${ctx.uploadFiles}`);
        proc = proc.then(() => {
          return $.make('mediaids');
        }).then((mediaids) => {
          return ctx.mediaIds = mediaids;
        });
      }
      proc.then(() => {
        return $.make("twitterClient");
      }).then((T) => {
        var ref7, ref8, ref9, v;
        //D "#{JSON.stringify T}"
        D(`rest command:${ctx.restCommand}`);
        D(`rest param:${JSON.stringify(ctx.restParam)}`);
        ref7 = ctx.restParam;
        for (k in ref7) {
          v = ref7[k];
          if (v === '@MEDIAIDS@') {
            D('found @MEDIAIDS@ in rest param.replace to actual media ids');
            if (ctx.mediaIds == null) {
              throw '@MEDIAIDS@ specified but no -m option';
            }
            ctx.restParam[k] = ctx.mediaIds;
          }
        }
        switch (ctx.command) {
          case 'GET':
            return T.get(ctx.restCommand, (ref8 = ctx.restParam) != null ? ref8 : {}, restCallback);
          case 'POST':
            return T.post(ctx.restCommand, (ref9 = ctx.restParam) != null ? ref9 : {}, restCallback);
        }
      }).catch((e) => {
        return E(e);
      });
      break;
    case 'initUser':
      $.clearCache(`accessTokens-${ctx.userName}`);
      $.remake(`accessTokens-${ctx.userName}`).catch((e) => {
        return E(e);
      });
      break;
    case 'initAll':
      $.clearCache();
      $.remake("consumerKeys").catch((e) => {
        return E(e);
      });
  }
} catch (error1) {
  e = error1;
  E(e);
}
